"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  AccessDeniedException: () => AccessDeniedException,
  ApplyPendingMaintenanceActionCommand: () => ApplyPendingMaintenanceActionCommand,
  Auth: () => Auth,
  ConflictException: () => ConflictException,
  CopyClusterSnapshotCommand: () => CopyClusterSnapshotCommand,
  CreateClusterCommand: () => CreateClusterCommand,
  CreateClusterInputFilterSensitiveLog: () => CreateClusterInputFilterSensitiveLog,
  CreateClusterSnapshotCommand: () => CreateClusterSnapshotCommand,
  DeleteClusterCommand: () => DeleteClusterCommand,
  DeleteClusterSnapshotCommand: () => DeleteClusterSnapshotCommand,
  DocDBElastic: () => DocDBElastic,
  DocDBElasticClient: () => DocDBElasticClient,
  DocDBElasticServiceException: () => DocDBElasticServiceException,
  GetClusterCommand: () => GetClusterCommand,
  GetClusterSnapshotCommand: () => GetClusterSnapshotCommand,
  GetPendingMaintenanceActionCommand: () => GetPendingMaintenanceActionCommand,
  InternalServerException: () => InternalServerException,
  ListClusterSnapshotsCommand: () => ListClusterSnapshotsCommand,
  ListClustersCommand: () => ListClustersCommand,
  ListPendingMaintenanceActionsCommand: () => ListPendingMaintenanceActionsCommand,
  ListTagsForResourceCommand: () => ListTagsForResourceCommand,
  OptInType: () => OptInType,
  ResourceNotFoundException: () => ResourceNotFoundException,
  RestoreClusterFromSnapshotCommand: () => RestoreClusterFromSnapshotCommand,
  ServiceQuotaExceededException: () => ServiceQuotaExceededException,
  SnapshotType: () => SnapshotType,
  StartClusterCommand: () => StartClusterCommand,
  Status: () => Status,
  StopClusterCommand: () => StopClusterCommand,
  TagResourceCommand: () => TagResourceCommand,
  ThrottlingException: () => ThrottlingException,
  UntagResourceCommand: () => UntagResourceCommand,
  UpdateClusterCommand: () => UpdateClusterCommand,
  UpdateClusterInputFilterSensitiveLog: () => UpdateClusterInputFilterSensitiveLog,
  ValidationException: () => ValidationException,
  ValidationExceptionReason: () => ValidationExceptionReason,
  __Client: () => import_smithy_client.Client,
  paginateListClusterSnapshots: () => paginateListClusterSnapshots,
  paginateListClusters: () => paginateListClusters,
  paginateListPendingMaintenanceActions: () => paginateListPendingMaintenanceActions
});
module.exports = __toCommonJS(index_exports);

// src/DocDBElasticClient.ts
var import_middleware_host_header = require("@aws-sdk/middleware-host-header");
var import_middleware_logger = require("@aws-sdk/middleware-logger");
var import_middleware_recursion_detection = require("@aws-sdk/middleware-recursion-detection");
var import_middleware_user_agent = require("@aws-sdk/middleware-user-agent");
var import_config_resolver = require("@smithy/config-resolver");
var import_core = require("@smithy/core");
var import_middleware_content_length = require("@smithy/middleware-content-length");
var import_middleware_endpoint = require("@smithy/middleware-endpoint");
var import_middleware_retry = require("@smithy/middleware-retry");

var import_httpAuthSchemeProvider = require("./auth/httpAuthSchemeProvider");

// src/endpoint/EndpointParameters.ts
var resolveClientEndpointParameters = /* @__PURE__ */ __name((options) => {
  return Object.assign(options, {
    useDualstackEndpoint: options.useDualstackEndpoint ?? false,
    useFipsEndpoint: options.useFipsEndpoint ?? false,
    defaultSigningName: "docdb-elastic"
  });
}, "resolveClientEndpointParameters");
var commonParams = {
  UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
  Endpoint: { type: "builtInParams", name: "endpoint" },
  Region: { type: "builtInParams", name: "region" },
  UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
};

// src/DocDBElasticClient.ts
var import_runtimeConfig = require("././runtimeConfig");

// src/runtimeExtensions.ts
var import_region_config_resolver = require("@aws-sdk/region-config-resolver");
var import_protocol_http = require("@smithy/protocol-http");
var import_smithy_client = require("@smithy/smithy-client");

// src/auth/httpAuthExtensionConfiguration.ts
var getHttpAuthExtensionConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
}, "getHttpAuthExtensionConfiguration");
var resolveHttpAuthRuntimeConfig = /* @__PURE__ */ __name((config) => {
  return {
    httpAuthSchemes: config.httpAuthSchemes(),
    httpAuthSchemeProvider: config.httpAuthSchemeProvider(),
    credentials: config.credentials()
  };
}, "resolveHttpAuthRuntimeConfig");

// src/runtimeExtensions.ts
var resolveRuntimeExtensions = /* @__PURE__ */ __name((runtimeConfig, extensions) => {
  const extensionConfiguration = Object.assign(
    (0, import_region_config_resolver.getAwsRegionExtensionConfiguration)(runtimeConfig),
    (0, import_smithy_client.getDefaultExtensionConfiguration)(runtimeConfig),
    (0, import_protocol_http.getHttpHandlerExtensionConfiguration)(runtimeConfig),
    getHttpAuthExtensionConfiguration(runtimeConfig)
  );
  extensions.forEach((extension) => extension.configure(extensionConfiguration));
  return Object.assign(
    runtimeConfig,
    (0, import_region_config_resolver.resolveAwsRegionExtensionConfiguration)(extensionConfiguration),
    (0, import_smithy_client.resolveDefaultRuntimeConfig)(extensionConfiguration),
    (0, import_protocol_http.resolveHttpHandlerRuntimeConfig)(extensionConfiguration),
    resolveHttpAuthRuntimeConfig(extensionConfiguration)
  );
}, "resolveRuntimeExtensions");

// src/DocDBElasticClient.ts
var DocDBElasticClient = class extends import_smithy_client.Client {
  static {
    __name(this, "DocDBElasticClient");
  }
  /**
   * The resolved configuration of DocDBElasticClient class. This is resolved and normalized from the {@link DocDBElasticClientConfig | constructor configuration interface}.
   */
  config;
  constructor(...[configuration]) {
    const _config_0 = (0, import_runtimeConfig.getRuntimeConfig)(configuration || {});
    super(_config_0);
    this.initConfig = _config_0;
    const _config_1 = resolveClientEndpointParameters(_config_0);
    const _config_2 = (0, import_middleware_user_agent.resolveUserAgentConfig)(_config_1);
    const _config_3 = (0, import_middleware_retry.resolveRetryConfig)(_config_2);
    const _config_4 = (0, import_config_resolver.resolveRegionConfig)(_config_3);
    const _config_5 = (0, import_middleware_host_header.resolveHostHeaderConfig)(_config_4);
    const _config_6 = (0, import_middleware_endpoint.resolveEndpointConfig)(_config_5);
    const _config_7 = (0, import_httpAuthSchemeProvider.resolveHttpAuthSchemeConfig)(_config_6);
    const _config_8 = resolveRuntimeExtensions(_config_7, configuration?.extensions || []);
    this.config = _config_8;
    this.middlewareStack.use((0, import_middleware_user_agent.getUserAgentPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_retry.getRetryPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_content_length.getContentLengthPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_host_header.getHostHeaderPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_logger.getLoggerPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_recursion_detection.getRecursionDetectionPlugin)(this.config));
    this.middlewareStack.use(
      (0, import_core.getHttpAuthSchemeEndpointRuleSetPlugin)(this.config, {
        httpAuthSchemeParametersProvider: import_httpAuthSchemeProvider.defaultDocDBElasticHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: /* @__PURE__ */ __name(async (config) => new import_core.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config.credentials
        }), "identityProviderConfigProvider")
      })
    );
    this.middlewareStack.use((0, import_core.getHttpSigningPlugin)(this.config));
  }
  /**
   * Destroy underlying resources, like sockets. It's usually not necessary to do this.
   * However in Node.js, it's best to explicitly shut down the client's agent when it is no longer needed.
   * Otherwise, sockets might stay open for quite a long time before the server terminates them.
   */
  destroy() {
    super.destroy();
  }
};

// src/DocDBElastic.ts


// src/commands/ApplyPendingMaintenanceActionCommand.ts

var import_middleware_serde = require("@smithy/middleware-serde");


// src/protocols/Aws_restJson1.ts
var import_core2 = require("@aws-sdk/core");


var import_uuid = require("uuid");

// src/models/DocDBElasticServiceException.ts

var DocDBElasticServiceException = class _DocDBElasticServiceException extends import_smithy_client.ServiceException {
  static {
    __name(this, "DocDBElasticServiceException");
  }
  /**
   * @internal
   */
  constructor(options) {
    super(options);
    Object.setPrototypeOf(this, _DocDBElasticServiceException.prototype);
  }
};

// src/models/models_0.ts

var AccessDeniedException = class _AccessDeniedException extends DocDBElasticServiceException {
  static {
    __name(this, "AccessDeniedException");
  }
  name = "AccessDeniedException";
  $fault = "client";
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "AccessDeniedException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _AccessDeniedException.prototype);
  }
};
var OptInType = {
  APPLY_ON: "APPLY_ON",
  IMMEDIATE: "IMMEDIATE",
  NEXT_MAINTENANCE: "NEXT_MAINTENANCE",
  UNDO_OPT_IN: "UNDO_OPT_IN"
};
var ConflictException = class _ConflictException extends DocDBElasticServiceException {
  static {
    __name(this, "ConflictException");
  }
  name = "ConflictException";
  $fault = "client";
  /**
   * <p>The ID of the resource where there was an access conflict.</p>
   * @public
   */
  resourceId;
  /**
   * <p>The type of the resource where there was an access conflict.</p>
   * @public
   */
  resourceType;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ConflictException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ConflictException.prototype);
    this.resourceId = opts.resourceId;
    this.resourceType = opts.resourceType;
  }
};
var InternalServerException = class _InternalServerException extends DocDBElasticServiceException {
  static {
    __name(this, "InternalServerException");
  }
  name = "InternalServerException";
  $fault = "server";
  $retryable = {};
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "InternalServerException",
      $fault: "server",
      ...opts
    });
    Object.setPrototypeOf(this, _InternalServerException.prototype);
  }
};
var ResourceNotFoundException = class _ResourceNotFoundException extends DocDBElasticServiceException {
  static {
    __name(this, "ResourceNotFoundException");
  }
  name = "ResourceNotFoundException";
  $fault = "client";
  /**
   * <p>The ID of the resource that could not be located.</p>
   * @public
   */
  resourceId;
  /**
   * <p>The type of the resource that could not be found.</p>
   * @public
   */
  resourceType;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ResourceNotFoundException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ResourceNotFoundException.prototype);
    this.resourceId = opts.resourceId;
    this.resourceType = opts.resourceType;
  }
};
var ThrottlingException = class _ThrottlingException extends DocDBElasticServiceException {
  static {
    __name(this, "ThrottlingException");
  }
  name = "ThrottlingException";
  $fault = "client";
  $retryable = {};
  /**
   * <p>The number of seconds to wait before retrying the operation.</p>
   * @public
   */
  retryAfterSeconds;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ThrottlingException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ThrottlingException.prototype);
    this.retryAfterSeconds = opts.retryAfterSeconds;
  }
};
var ValidationExceptionReason = {
  CANNOT_PARSE: "cannotParse",
  FIELD_VALIDATION_FAILED: "fieldValidationFailed",
  OTHER: "other",
  UNKNOWN_OPERATION: "unknownOperation"
};
var ValidationException = class _ValidationException extends DocDBElasticServiceException {
  static {
    __name(this, "ValidationException");
  }
  name = "ValidationException";
  $fault = "client";
  /**
   * <p>The reason why the validation exception occurred (one of <code>unknownOperation</code>,
   *       <code>cannotParse</code>, <code>fieldValidationFailed</code>, or <code>other</code>).</p>
   * @public
   */
  reason;
  /**
   * <p>A list of the fields in which the validation exception occurred.</p>
   * @public
   */
  fieldList;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ValidationException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ValidationException.prototype);
    this.reason = opts.reason;
    this.fieldList = opts.fieldList;
  }
};
var Auth = {
  PLAIN_TEXT: "PLAIN_TEXT",
  SECRET_ARN: "SECRET_ARN"
};
var SnapshotType = {
  AUTOMATED: "AUTOMATED",
  MANUAL: "MANUAL"
};
var Status = {
  ACTIVE: "ACTIVE",
  COPYING: "COPYING",
  CREATING: "CREATING",
  DELETING: "DELETING",
  INACCESSIBLE_ENCRYPTION_CREDENTIALS_RECOVERABLE: "INACCESSIBLE_ENCRYPTION_CREDENTIALS_RECOVERABLE",
  INACCESSIBLE_ENCRYPTION_CREDS: "INACCESSIBLE_ENCRYPTION_CREDS",
  INACCESSIBLE_SECRET_ARN: "INACCESSIBLE_SECRET_ARN",
  INACCESSIBLE_VPC_ENDPOINT: "INACCESSIBLE_VPC_ENDPOINT",
  INCOMPATIBLE_NETWORK: "INCOMPATIBLE_NETWORK",
  INVALID_SECURITY_GROUP_ID: "INVALID_SECURITY_GROUP_ID",
  INVALID_SUBNET_ID: "INVALID_SUBNET_ID",
  IP_ADDRESS_LIMIT_EXCEEDED: "IP_ADDRESS_LIMIT_EXCEEDED",
  MAINTENANCE: "MAINTENANCE",
  MERGING: "MERGING",
  MODIFYING: "MODIFYING",
  SPLITTING: "SPLITTING",
  STARTING: "STARTING",
  STOPPED: "STOPPED",
  STOPPING: "STOPPING",
  UPDATING: "UPDATING",
  VPC_ENDPOINT_LIMIT_EXCEEDED: "VPC_ENDPOINT_LIMIT_EXCEEDED"
};
var ServiceQuotaExceededException = class _ServiceQuotaExceededException extends DocDBElasticServiceException {
  static {
    __name(this, "ServiceQuotaExceededException");
  }
  name = "ServiceQuotaExceededException";
  $fault = "client";
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ServiceQuotaExceededException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ServiceQuotaExceededException.prototype);
  }
};
var CreateClusterInputFilterSensitiveLog = /* @__PURE__ */ __name((obj) => ({
  ...obj,
  ...obj.adminUserPassword && { adminUserPassword: import_smithy_client.SENSITIVE_STRING }
}), "CreateClusterInputFilterSensitiveLog");
var UpdateClusterInputFilterSensitiveLog = /* @__PURE__ */ __name((obj) => ({
  ...obj,
  ...obj.adminUserPassword && { adminUserPassword: import_smithy_client.SENSITIVE_STRING }
}), "UpdateClusterInputFilterSensitiveLog");

// src/protocols/Aws_restJson1.ts
var se_ApplyPendingMaintenanceActionCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/pending-action");
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      applyAction: [],
      applyOn: [],
      optInType: [],
      resourceArn: []
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_ApplyPendingMaintenanceActionCommand");
var se_CopyClusterSnapshotCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/cluster-snapshot/{snapshotArn}/copy");
  b.p("snapshotArn", () => input.snapshotArn, "{snapshotArn}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      copyTags: [],
      kmsKeyId: [],
      tags: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "tags"),
      targetSnapshotName: []
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_CopyClusterSnapshotCommand");
var se_CreateClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/cluster");
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      adminUserName: [],
      adminUserPassword: [],
      authType: [],
      backupRetentionPeriod: [],
      clientToken: [true, (_) => _ ?? (0, import_uuid.v4)()],
      clusterName: [],
      kmsKeyId: [],
      preferredBackupWindow: [],
      preferredMaintenanceWindow: [],
      shardCapacity: [],
      shardCount: [],
      shardInstanceCount: [],
      subnetIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "subnetIds"),
      tags: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "tags"),
      vpcSecurityGroupIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "vpcSecurityGroupIds")
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_CreateClusterCommand");
var se_CreateClusterSnapshotCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/cluster-snapshot");
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      clusterArn: [],
      snapshotName: [],
      tags: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "tags")
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_CreateClusterSnapshotCommand");
var se_DeleteClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster/{clusterArn}");
  b.p("clusterArn", () => input.clusterArn, "{clusterArn}", false);
  let body;
  b.m("DELETE").h(headers).b(body);
  return b.build();
}, "se_DeleteClusterCommand");
var se_DeleteClusterSnapshotCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster-snapshot/{snapshotArn}");
  b.p("snapshotArn", () => input.snapshotArn, "{snapshotArn}", false);
  let body;
  b.m("DELETE").h(headers).b(body);
  return b.build();
}, "se_DeleteClusterSnapshotCommand");
var se_GetClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster/{clusterArn}");
  b.p("clusterArn", () => input.clusterArn, "{clusterArn}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_GetClusterCommand");
var se_GetClusterSnapshotCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster-snapshot/{snapshotArn}");
  b.p("snapshotArn", () => input.snapshotArn, "{snapshotArn}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_GetClusterSnapshotCommand");
var se_GetPendingMaintenanceActionCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/pending-action/{resourceArn}");
  b.p("resourceArn", () => input.resourceArn, "{resourceArn}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_GetPendingMaintenanceActionCommand");
var se_ListClustersCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/clusters");
  const query = (0, import_smithy_client.map)({
    [_nT]: [, input[_nT]],
    [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()]
  });
  let body;
  b.m("GET").h(headers).q(query).b(body);
  return b.build();
}, "se_ListClustersCommand");
var se_ListClusterSnapshotsCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster-snapshots");
  const query = (0, import_smithy_client.map)({
    [_cA]: [, input[_cA]],
    [_nT]: [, input[_nT]],
    [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()],
    [_sT]: [, input[_sT]]
  });
  let body;
  b.m("GET").h(headers).q(query).b(body);
  return b.build();
}, "se_ListClusterSnapshotsCommand");
var se_ListPendingMaintenanceActionsCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/pending-actions");
  const query = (0, import_smithy_client.map)({
    [_nT]: [, input[_nT]],
    [_mR]: [() => input.maxResults !== void 0, () => input[_mR].toString()]
  });
  let body;
  b.m("GET").h(headers).q(query).b(body);
  return b.build();
}, "se_ListPendingMaintenanceActionsCommand");
var se_ListTagsForResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/tags/{resourceArn}");
  b.p("resourceArn", () => input.resourceArn, "{resourceArn}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_ListTagsForResourceCommand");
var se_RestoreClusterFromSnapshotCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/cluster-snapshot/{snapshotArn}/restore");
  b.p("snapshotArn", () => input.snapshotArn, "{snapshotArn}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      clusterName: [],
      kmsKeyId: [],
      shardCapacity: [],
      shardInstanceCount: [],
      subnetIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "subnetIds"),
      tags: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "tags"),
      vpcSecurityGroupIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "vpcSecurityGroupIds")
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_RestoreClusterFromSnapshotCommand");
var se_StartClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster/{clusterArn}/start");
  b.p("clusterArn", () => input.clusterArn, "{clusterArn}", false);
  let body;
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_StartClusterCommand");
var se_StopClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/cluster/{clusterArn}/stop");
  b.p("clusterArn", () => input.clusterArn, "{clusterArn}", false);
  let body;
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_StopClusterCommand");
var se_TagResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/tags/{resourceArn}");
  b.p("resourceArn", () => input.resourceArn, "{resourceArn}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      tags: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "tags")
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_TagResourceCommand");
var se_UntagResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/tags/{resourceArn}");
  b.p("resourceArn", () => input.resourceArn, "{resourceArn}", false);
  const query = (0, import_smithy_client.map)({
    [_tK]: [(0, import_smithy_client.expectNonNull)(input.tagKeys, `tagKeys`) != null, () => input[_tK] || []]
  });
  let body;
  b.m("DELETE").h(headers).q(query).b(body);
  return b.build();
}, "se_UntagResourceCommand");
var se_UpdateClusterCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/cluster/{clusterArn}");
  b.p("clusterArn", () => input.clusterArn, "{clusterArn}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      adminUserPassword: [],
      authType: [],
      backupRetentionPeriod: [],
      clientToken: [true, (_) => _ ?? (0, import_uuid.v4)()],
      preferredBackupWindow: [],
      preferredMaintenanceWindow: [],
      shardCapacity: [],
      shardCount: [],
      shardInstanceCount: [],
      subnetIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "subnetIds"),
      vpcSecurityGroupIds: /* @__PURE__ */ __name((_) => (0, import_smithy_client._json)(_), "vpcSecurityGroupIds")
    })
  );
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_UpdateClusterCommand");
var de_ApplyPendingMaintenanceActionCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    resourcePendingMaintenanceAction: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ApplyPendingMaintenanceActionCommand");
var de_CopyClusterSnapshotCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    snapshot: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_CopyClusterSnapshotCommand");
var de_CreateClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_CreateClusterCommand");
var de_CreateClusterSnapshotCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    snapshot: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_CreateClusterSnapshotCommand");
var de_DeleteClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_DeleteClusterCommand");
var de_DeleteClusterSnapshotCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    snapshot: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_DeleteClusterSnapshotCommand");
var de_GetClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_GetClusterCommand");
var de_GetClusterSnapshotCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    snapshot: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_GetClusterSnapshotCommand");
var de_GetPendingMaintenanceActionCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    resourcePendingMaintenanceAction: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_GetPendingMaintenanceActionCommand");
var de_ListClustersCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    clusters: import_smithy_client._json,
    nextToken: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListClustersCommand");
var de_ListClusterSnapshotsCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    nextToken: import_smithy_client.expectString,
    snapshots: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListClusterSnapshotsCommand");
var de_ListPendingMaintenanceActionsCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    nextToken: import_smithy_client.expectString,
    resourcePendingMaintenanceActions: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListPendingMaintenanceActionsCommand");
var de_ListTagsForResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    tags: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListTagsForResourceCommand");
var de_RestoreClusterFromSnapshotCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_RestoreClusterFromSnapshotCommand");
var de_StartClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_StartClusterCommand");
var de_StopClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_StopClusterCommand");
var de_TagResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  await (0, import_smithy_client.collectBody)(output.body, context);
  return contents;
}, "de_TagResourceCommand");
var de_UntagResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  await (0, import_smithy_client.collectBody)(output.body, context);
  return contents;
}, "de_UntagResourceCommand");
var de_UpdateClusterCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    cluster: import_smithy_client._json
  });
  Object.assign(contents, doc);
  return contents;
}, "de_UpdateClusterCommand");
var de_CommandError = /* @__PURE__ */ __name(async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await (0, import_core2.parseJsonErrorBody)(output.body, context)
  };
  const errorCode = (0, import_core2.loadRestJsonErrorCode)(output, parsedOutput.body);
  switch (errorCode) {
    case "AccessDeniedException":
    case "com.amazonaws.docdbelastic#AccessDeniedException":
      throw await de_AccessDeniedExceptionRes(parsedOutput, context);
    case "ConflictException":
    case "com.amazonaws.docdbelastic#ConflictException":
      throw await de_ConflictExceptionRes(parsedOutput, context);
    case "InternalServerException":
    case "com.amazonaws.docdbelastic#InternalServerException":
      throw await de_InternalServerExceptionRes(parsedOutput, context);
    case "ResourceNotFoundException":
    case "com.amazonaws.docdbelastic#ResourceNotFoundException":
      throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
    case "ThrottlingException":
    case "com.amazonaws.docdbelastic#ThrottlingException":
      throw await de_ThrottlingExceptionRes(parsedOutput, context);
    case "ValidationException":
    case "com.amazonaws.docdbelastic#ValidationException":
      throw await de_ValidationExceptionRes(parsedOutput, context);
    case "ServiceQuotaExceededException":
    case "com.amazonaws.docdbelastic#ServiceQuotaExceededException":
      throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError({
        output,
        parsedBody,
        errorCode
      });
  }
}, "de_CommandError");
var throwDefaultError = (0, import_smithy_client.withBaseException)(DocDBElasticServiceException);
var de_AccessDeniedExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new AccessDeniedException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_AccessDeniedExceptionRes");
var de_ConflictExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString,
    resourceId: import_smithy_client.expectString,
    resourceType: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new ConflictException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ConflictExceptionRes");
var de_InternalServerExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new InternalServerException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_InternalServerExceptionRes");
var de_ResourceNotFoundExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString,
    resourceId: import_smithy_client.expectString,
    resourceType: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new ResourceNotFoundException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ResourceNotFoundExceptionRes");
var de_ServiceQuotaExceededExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new ServiceQuotaExceededException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ServiceQuotaExceededExceptionRes");
var de_ThrottlingExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({
    [_rAS]: [() => void 0 !== parsedOutput.headers[_ra], () => (0, import_smithy_client.strictParseInt32)(parsedOutput.headers[_ra])]
  });
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    message: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new ThrottlingException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ThrottlingExceptionRes");
var de_ValidationExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    fieldList: import_smithy_client._json,
    message: import_smithy_client.expectString,
    reason: import_smithy_client.expectString
  });
  Object.assign(contents, doc);
  const exception = new ValidationException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ValidationExceptionRes");
var deserializeMetadata = /* @__PURE__ */ __name((output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
}), "deserializeMetadata");
var _cA = "clusterArn";
var _mR = "maxResults";
var _nT = "nextToken";
var _rAS = "retryAfterSeconds";
var _ra = "retry-after";
var _sT = "snapshotType";
var _tK = "tagKeys";

// src/commands/ApplyPendingMaintenanceActionCommand.ts
var ApplyPendingMaintenanceActionCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "ApplyPendingMaintenanceAction", {}).n("DocDBElasticClient", "ApplyPendingMaintenanceActionCommand").f(void 0, void 0).ser(se_ApplyPendingMaintenanceActionCommand).de(de_ApplyPendingMaintenanceActionCommand).build() {
  static {
    __name(this, "ApplyPendingMaintenanceActionCommand");
  }
};

// src/commands/CopyClusterSnapshotCommand.ts



var CopyClusterSnapshotCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "CopyClusterSnapshot", {}).n("DocDBElasticClient", "CopyClusterSnapshotCommand").f(void 0, void 0).ser(se_CopyClusterSnapshotCommand).de(de_CopyClusterSnapshotCommand).build() {
  static {
    __name(this, "CopyClusterSnapshotCommand");
  }
};

// src/commands/CreateClusterCommand.ts



var CreateClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "CreateCluster", {}).n("DocDBElasticClient", "CreateClusterCommand").f(CreateClusterInputFilterSensitiveLog, void 0).ser(se_CreateClusterCommand).de(de_CreateClusterCommand).build() {
  static {
    __name(this, "CreateClusterCommand");
  }
};

// src/commands/CreateClusterSnapshotCommand.ts



var CreateClusterSnapshotCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "CreateClusterSnapshot", {}).n("DocDBElasticClient", "CreateClusterSnapshotCommand").f(void 0, void 0).ser(se_CreateClusterSnapshotCommand).de(de_CreateClusterSnapshotCommand).build() {
  static {
    __name(this, "CreateClusterSnapshotCommand");
  }
};

// src/commands/DeleteClusterCommand.ts



var DeleteClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "DeleteCluster", {}).n("DocDBElasticClient", "DeleteClusterCommand").f(void 0, void 0).ser(se_DeleteClusterCommand).de(de_DeleteClusterCommand).build() {
  static {
    __name(this, "DeleteClusterCommand");
  }
};

// src/commands/DeleteClusterSnapshotCommand.ts



var DeleteClusterSnapshotCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "DeleteClusterSnapshot", {}).n("DocDBElasticClient", "DeleteClusterSnapshotCommand").f(void 0, void 0).ser(se_DeleteClusterSnapshotCommand).de(de_DeleteClusterSnapshotCommand).build() {
  static {
    __name(this, "DeleteClusterSnapshotCommand");
  }
};

// src/commands/GetClusterCommand.ts



var GetClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "GetCluster", {}).n("DocDBElasticClient", "GetClusterCommand").f(void 0, void 0).ser(se_GetClusterCommand).de(de_GetClusterCommand).build() {
  static {
    __name(this, "GetClusterCommand");
  }
};

// src/commands/GetClusterSnapshotCommand.ts



var GetClusterSnapshotCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "GetClusterSnapshot", {}).n("DocDBElasticClient", "GetClusterSnapshotCommand").f(void 0, void 0).ser(se_GetClusterSnapshotCommand).de(de_GetClusterSnapshotCommand).build() {
  static {
    __name(this, "GetClusterSnapshotCommand");
  }
};

// src/commands/GetPendingMaintenanceActionCommand.ts



var GetPendingMaintenanceActionCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "GetPendingMaintenanceAction", {}).n("DocDBElasticClient", "GetPendingMaintenanceActionCommand").f(void 0, void 0).ser(se_GetPendingMaintenanceActionCommand).de(de_GetPendingMaintenanceActionCommand).build() {
  static {
    __name(this, "GetPendingMaintenanceActionCommand");
  }
};

// src/commands/ListClustersCommand.ts



var ListClustersCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "ListClusters", {}).n("DocDBElasticClient", "ListClustersCommand").f(void 0, void 0).ser(se_ListClustersCommand).de(de_ListClustersCommand).build() {
  static {
    __name(this, "ListClustersCommand");
  }
};

// src/commands/ListClusterSnapshotsCommand.ts



var ListClusterSnapshotsCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "ListClusterSnapshots", {}).n("DocDBElasticClient", "ListClusterSnapshotsCommand").f(void 0, void 0).ser(se_ListClusterSnapshotsCommand).de(de_ListClusterSnapshotsCommand).build() {
  static {
    __name(this, "ListClusterSnapshotsCommand");
  }
};

// src/commands/ListPendingMaintenanceActionsCommand.ts



var ListPendingMaintenanceActionsCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "ListPendingMaintenanceActions", {}).n("DocDBElasticClient", "ListPendingMaintenanceActionsCommand").f(void 0, void 0).ser(se_ListPendingMaintenanceActionsCommand).de(de_ListPendingMaintenanceActionsCommand).build() {
  static {
    __name(this, "ListPendingMaintenanceActionsCommand");
  }
};

// src/commands/ListTagsForResourceCommand.ts



var ListTagsForResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "ListTagsForResource", {}).n("DocDBElasticClient", "ListTagsForResourceCommand").f(void 0, void 0).ser(se_ListTagsForResourceCommand).de(de_ListTagsForResourceCommand).build() {
  static {
    __name(this, "ListTagsForResourceCommand");
  }
};

// src/commands/RestoreClusterFromSnapshotCommand.ts



var RestoreClusterFromSnapshotCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "RestoreClusterFromSnapshot", {}).n("DocDBElasticClient", "RestoreClusterFromSnapshotCommand").f(void 0, void 0).ser(se_RestoreClusterFromSnapshotCommand).de(de_RestoreClusterFromSnapshotCommand).build() {
  static {
    __name(this, "RestoreClusterFromSnapshotCommand");
  }
};

// src/commands/StartClusterCommand.ts



var StartClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "StartCluster", {}).n("DocDBElasticClient", "StartClusterCommand").f(void 0, void 0).ser(se_StartClusterCommand).de(de_StartClusterCommand).build() {
  static {
    __name(this, "StartClusterCommand");
  }
};

// src/commands/StopClusterCommand.ts



var StopClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "StopCluster", {}).n("DocDBElasticClient", "StopClusterCommand").f(void 0, void 0).ser(se_StopClusterCommand).de(de_StopClusterCommand).build() {
  static {
    __name(this, "StopClusterCommand");
  }
};

// src/commands/TagResourceCommand.ts



var TagResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "TagResource", {}).n("DocDBElasticClient", "TagResourceCommand").f(void 0, void 0).ser(se_TagResourceCommand).de(de_TagResourceCommand).build() {
  static {
    __name(this, "TagResourceCommand");
  }
};

// src/commands/UntagResourceCommand.ts



var UntagResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "UntagResource", {}).n("DocDBElasticClient", "UntagResourceCommand").f(void 0, void 0).ser(se_UntagResourceCommand).de(de_UntagResourceCommand).build() {
  static {
    __name(this, "UntagResourceCommand");
  }
};

// src/commands/UpdateClusterCommand.ts



var UpdateClusterCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ChimeraDbLionfishServiceLambda", "UpdateCluster", {}).n("DocDBElasticClient", "UpdateClusterCommand").f(UpdateClusterInputFilterSensitiveLog, void 0).ser(se_UpdateClusterCommand).de(de_UpdateClusterCommand).build() {
  static {
    __name(this, "UpdateClusterCommand");
  }
};

// src/DocDBElastic.ts
var commands = {
  ApplyPendingMaintenanceActionCommand,
  CopyClusterSnapshotCommand,
  CreateClusterCommand,
  CreateClusterSnapshotCommand,
  DeleteClusterCommand,
  DeleteClusterSnapshotCommand,
  GetClusterCommand,
  GetClusterSnapshotCommand,
  GetPendingMaintenanceActionCommand,
  ListClustersCommand,
  ListClusterSnapshotsCommand,
  ListPendingMaintenanceActionsCommand,
  ListTagsForResourceCommand,
  RestoreClusterFromSnapshotCommand,
  StartClusterCommand,
  StopClusterCommand,
  TagResourceCommand,
  UntagResourceCommand,
  UpdateClusterCommand
};
var DocDBElastic = class extends DocDBElasticClient {
  static {
    __name(this, "DocDBElastic");
  }
};
(0, import_smithy_client.createAggregatedClient)(commands, DocDBElastic);

// src/pagination/ListClusterSnapshotsPaginator.ts

var paginateListClusterSnapshots = (0, import_core.createPaginator)(DocDBElasticClient, ListClusterSnapshotsCommand, "nextToken", "nextToken", "maxResults");

// src/pagination/ListClustersPaginator.ts

var paginateListClusters = (0, import_core.createPaginator)(DocDBElasticClient, ListClustersCommand, "nextToken", "nextToken", "maxResults");

// src/pagination/ListPendingMaintenanceActionsPaginator.ts

var paginateListPendingMaintenanceActions = (0, import_core.createPaginator)(DocDBElasticClient, ListPendingMaintenanceActionsCommand, "nextToken", "nextToken", "maxResults");
// Annotate the CommonJS export names for ESM import in node:

0 && (module.exports = {
  DocDBElasticServiceException,
  __Client,
  DocDBElasticClient,
  DocDBElastic,
  $Command,
  ApplyPendingMaintenanceActionCommand,
  CopyClusterSnapshotCommand,
  CreateClusterCommand,
  CreateClusterSnapshotCommand,
  DeleteClusterCommand,
  DeleteClusterSnapshotCommand,
  GetClusterCommand,
  GetClusterSnapshotCommand,
  GetPendingMaintenanceActionCommand,
  ListClusterSnapshotsCommand,
  ListClustersCommand,
  ListPendingMaintenanceActionsCommand,
  ListTagsForResourceCommand,
  RestoreClusterFromSnapshotCommand,
  StartClusterCommand,
  StopClusterCommand,
  TagResourceCommand,
  UntagResourceCommand,
  UpdateClusterCommand,
  paginateListClusterSnapshots,
  paginateListClusters,
  paginateListPendingMaintenanceActions,
  AccessDeniedException,
  OptInType,
  ConflictException,
  InternalServerException,
  ResourceNotFoundException,
  ThrottlingException,
  ValidationExceptionReason,
  ValidationException,
  Auth,
  SnapshotType,
  Status,
  ServiceQuotaExceededException,
  CreateClusterInputFilterSensitiveLog,
  UpdateClusterInputFilterSensitiveLog
});

