import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetPendingMaintenanceActionCommand, se_GetPendingMaintenanceActionCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class GetPendingMaintenanceActionCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeraDbLionfishServiceLambda", "GetPendingMaintenanceAction", {})
    .n("DocDBElasticClient", "GetPendingMaintenanceActionCommand")
    .f(void 0, void 0)
    .ser(se_GetPendingMaintenanceActionCommand)
    .de(de_GetPendingMaintenanceActionCommand)
    .build() {
}
