import { SENSITIVE_STRING } from "@smithy/smithy-client";
import { DocDBElasticServiceException as __BaseException } from "./DocDBElasticServiceException";
export class AccessDeniedException extends __BaseException {
    name = "AccessDeniedException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
    }
}
export const OptInType = {
    APPLY_ON: "APPLY_ON",
    IMMEDIATE: "IMMEDIATE",
    NEXT_MAINTENANCE: "NEXT_MAINTENANCE",
    UNDO_OPT_IN: "UNDO_OPT_IN",
};
export class ConflictException extends __BaseException {
    name = "ConflictException";
    $fault = "client";
    resourceId;
    resourceType;
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.resourceId = opts.resourceId;
        this.resourceType = opts.resourceType;
    }
}
export class InternalServerException extends __BaseException {
    name = "InternalServerException";
    $fault = "server";
    $retryable = {};
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        Object.setPrototypeOf(this, InternalServerException.prototype);
    }
}
export class ResourceNotFoundException extends __BaseException {
    name = "ResourceNotFoundException";
    $fault = "client";
    resourceId;
    resourceType;
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.resourceId = opts.resourceId;
        this.resourceType = opts.resourceType;
    }
}
export class ThrottlingException extends __BaseException {
    name = "ThrottlingException";
    $fault = "client";
    $retryable = {};
    retryAfterSeconds;
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.retryAfterSeconds = opts.retryAfterSeconds;
    }
}
export const ValidationExceptionReason = {
    CANNOT_PARSE: "cannotParse",
    FIELD_VALIDATION_FAILED: "fieldValidationFailed",
    OTHER: "other",
    UNKNOWN_OPERATION: "unknownOperation",
};
export class ValidationException extends __BaseException {
    name = "ValidationException";
    $fault = "client";
    reason;
    fieldList;
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.reason = opts.reason;
        this.fieldList = opts.fieldList;
    }
}
export const Auth = {
    PLAIN_TEXT: "PLAIN_TEXT",
    SECRET_ARN: "SECRET_ARN",
};
export const SnapshotType = {
    AUTOMATED: "AUTOMATED",
    MANUAL: "MANUAL",
};
export const Status = {
    ACTIVE: "ACTIVE",
    COPYING: "COPYING",
    CREATING: "CREATING",
    DELETING: "DELETING",
    INACCESSIBLE_ENCRYPTION_CREDENTIALS_RECOVERABLE: "INACCESSIBLE_ENCRYPTION_CREDENTIALS_RECOVERABLE",
    INACCESSIBLE_ENCRYPTION_CREDS: "INACCESSIBLE_ENCRYPTION_CREDS",
    INACCESSIBLE_SECRET_ARN: "INACCESSIBLE_SECRET_ARN",
    INACCESSIBLE_VPC_ENDPOINT: "INACCESSIBLE_VPC_ENDPOINT",
    INCOMPATIBLE_NETWORK: "INCOMPATIBLE_NETWORK",
    INVALID_SECURITY_GROUP_ID: "INVALID_SECURITY_GROUP_ID",
    INVALID_SUBNET_ID: "INVALID_SUBNET_ID",
    IP_ADDRESS_LIMIT_EXCEEDED: "IP_ADDRESS_LIMIT_EXCEEDED",
    MAINTENANCE: "MAINTENANCE",
    MERGING: "MERGING",
    MODIFYING: "MODIFYING",
    SPLITTING: "SPLITTING",
    STARTING: "STARTING",
    STOPPED: "STOPPED",
    STOPPING: "STOPPING",
    UPDATING: "UPDATING",
    VPC_ENDPOINT_LIMIT_EXCEEDED: "VPC_ENDPOINT_LIMIT_EXCEEDED",
};
export class ServiceQuotaExceededException extends __BaseException {
    name = "ServiceQuotaExceededException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
    }
}
export const CreateClusterInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.adminUserPassword && { adminUserPassword: SENSITIVE_STRING }),
});
export const UpdateClusterInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.adminUserPassword && { adminUserPassword: SENSITIVE_STRING }),
});
