import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { ApplyPendingMaintenanceActionCommandInput, ApplyPendingMaintenanceActionCommandOutput } from "../commands/ApplyPendingMaintenanceActionCommand";
import { CopyClusterSnapshotCommandInput, CopyClusterSnapshotCommandOutput } from "../commands/CopyClusterSnapshotCommand";
import { CreateClusterCommandInput, CreateClusterCommandOutput } from "../commands/CreateClusterCommand";
import { CreateClusterSnapshotCommandInput, CreateClusterSnapshotCommandOutput } from "../commands/CreateClusterSnapshotCommand";
import { DeleteClusterCommandInput, DeleteClusterCommandOutput } from "../commands/DeleteClusterCommand";
import { DeleteClusterSnapshotCommandInput, DeleteClusterSnapshotCommandOutput } from "../commands/DeleteClusterSnapshotCommand";
import { GetClusterCommandInput, GetClusterCommandOutput } from "../commands/GetClusterCommand";
import { GetClusterSnapshotCommandInput, GetClusterSnapshotCommandOutput } from "../commands/GetClusterSnapshotCommand";
import { GetPendingMaintenanceActionCommandInput, GetPendingMaintenanceActionCommandOutput } from "../commands/GetPendingMaintenanceActionCommand";
import { ListClustersCommandInput, ListClustersCommandOutput } from "../commands/ListClustersCommand";
import { ListClusterSnapshotsCommandInput, ListClusterSnapshotsCommandOutput } from "../commands/ListClusterSnapshotsCommand";
import { ListPendingMaintenanceActionsCommandInput, ListPendingMaintenanceActionsCommandOutput } from "../commands/ListPendingMaintenanceActionsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { RestoreClusterFromSnapshotCommandInput, RestoreClusterFromSnapshotCommandOutput } from "../commands/RestoreClusterFromSnapshotCommand";
import { StartClusterCommandInput, StartClusterCommandOutput } from "../commands/StartClusterCommand";
import { StopClusterCommandInput, StopClusterCommandOutput } from "../commands/StopClusterCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateClusterCommandInput, UpdateClusterCommandOutput } from "../commands/UpdateClusterCommand";
/**
 * serializeAws_restJson1ApplyPendingMaintenanceActionCommand
 */
export declare const se_ApplyPendingMaintenanceActionCommand: (input: ApplyPendingMaintenanceActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CopyClusterSnapshotCommand
 */
export declare const se_CopyClusterSnapshotCommand: (input: CopyClusterSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateClusterCommand
 */
export declare const se_CreateClusterCommand: (input: CreateClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateClusterSnapshotCommand
 */
export declare const se_CreateClusterSnapshotCommand: (input: CreateClusterSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteClusterCommand
 */
export declare const se_DeleteClusterCommand: (input: DeleteClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteClusterSnapshotCommand
 */
export declare const se_DeleteClusterSnapshotCommand: (input: DeleteClusterSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetClusterCommand
 */
export declare const se_GetClusterCommand: (input: GetClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetClusterSnapshotCommand
 */
export declare const se_GetClusterSnapshotCommand: (input: GetClusterSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetPendingMaintenanceActionCommand
 */
export declare const se_GetPendingMaintenanceActionCommand: (input: GetPendingMaintenanceActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListClustersCommand
 */
export declare const se_ListClustersCommand: (input: ListClustersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListClusterSnapshotsCommand
 */
export declare const se_ListClusterSnapshotsCommand: (input: ListClusterSnapshotsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListPendingMaintenanceActionsCommand
 */
export declare const se_ListPendingMaintenanceActionsCommand: (input: ListPendingMaintenanceActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1RestoreClusterFromSnapshotCommand
 */
export declare const se_RestoreClusterFromSnapshotCommand: (input: RestoreClusterFromSnapshotCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartClusterCommand
 */
export declare const se_StartClusterCommand: (input: StartClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StopClusterCommand
 */
export declare const se_StopClusterCommand: (input: StopClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateClusterCommand
 */
export declare const se_UpdateClusterCommand: (input: UpdateClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1ApplyPendingMaintenanceActionCommand
 */
export declare const de_ApplyPendingMaintenanceActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ApplyPendingMaintenanceActionCommandOutput>;
/**
 * deserializeAws_restJson1CopyClusterSnapshotCommand
 */
export declare const de_CopyClusterSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopyClusterSnapshotCommandOutput>;
/**
 * deserializeAws_restJson1CreateClusterCommand
 */
export declare const de_CreateClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateClusterCommandOutput>;
/**
 * deserializeAws_restJson1CreateClusterSnapshotCommand
 */
export declare const de_CreateClusterSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateClusterSnapshotCommandOutput>;
/**
 * deserializeAws_restJson1DeleteClusterCommand
 */
export declare const de_DeleteClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClusterCommandOutput>;
/**
 * deserializeAws_restJson1DeleteClusterSnapshotCommand
 */
export declare const de_DeleteClusterSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClusterSnapshotCommandOutput>;
/**
 * deserializeAws_restJson1GetClusterCommand
 */
export declare const de_GetClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetClusterCommandOutput>;
/**
 * deserializeAws_restJson1GetClusterSnapshotCommand
 */
export declare const de_GetClusterSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetClusterSnapshotCommandOutput>;
/**
 * deserializeAws_restJson1GetPendingMaintenanceActionCommand
 */
export declare const de_GetPendingMaintenanceActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPendingMaintenanceActionCommandOutput>;
/**
 * deserializeAws_restJson1ListClustersCommand
 */
export declare const de_ListClustersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListClustersCommandOutput>;
/**
 * deserializeAws_restJson1ListClusterSnapshotsCommand
 */
export declare const de_ListClusterSnapshotsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListClusterSnapshotsCommandOutput>;
/**
 * deserializeAws_restJson1ListPendingMaintenanceActionsCommand
 */
export declare const de_ListPendingMaintenanceActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPendingMaintenanceActionsCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_restJson1RestoreClusterFromSnapshotCommand
 */
export declare const de_RestoreClusterFromSnapshotCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RestoreClusterFromSnapshotCommandOutput>;
/**
 * deserializeAws_restJson1StartClusterCommand
 */
export declare const de_StartClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartClusterCommandOutput>;
/**
 * deserializeAws_restJson1StopClusterCommand
 */
export declare const de_StopClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopClusterCommandOutput>;
/**
 * deserializeAws_restJson1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateClusterCommand
 */
export declare const de_UpdateClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateClusterCommandOutput>;
