import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { DocDBElasticClientResolvedConfig } from "../DocDBElasticClient";
export interface DocDBElasticHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface DocDBElasticHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    DocDBElasticClientResolvedConfig,
    HandlerExecutionContext,
    DocDBElasticHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultDocDBElasticHttpAuthSchemeParametersProvider: (
  config: DocDBElasticClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<DocDBElasticHttpAuthSchemeParameters>;
export interface DocDBElasticHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<DocDBElasticHttpAuthSchemeParameters> {}
export declare const defaultDocDBElasticHttpAuthSchemeProvider: DocDBElasticHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: DocDBElasticHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: DocDBElasticHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
