import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  ApplyPendingMaintenanceActionCommandInput,
  ApplyPendingMaintenanceActionCommandOutput,
} from "../commands/ApplyPendingMaintenanceActionCommand";
import {
  CopyClusterSnapshotCommandInput,
  CopyClusterSnapshotCommandOutput,
} from "../commands/CopyClusterSnapshotCommand";
import {
  CreateClusterCommandInput,
  CreateClusterCommandOutput,
} from "../commands/CreateClusterCommand";
import {
  CreateClusterSnapshotCommandInput,
  CreateClusterSnapshotCommandOutput,
} from "../commands/CreateClusterSnapshotCommand";
import {
  DeleteClusterCommandInput,
  DeleteClusterCommandOutput,
} from "../commands/DeleteClusterCommand";
import {
  DeleteClusterSnapshotCommandInput,
  DeleteClusterSnapshotCommandOutput,
} from "../commands/DeleteClusterSnapshotCommand";
import {
  GetClusterCommandInput,
  GetClusterCommandOutput,
} from "../commands/GetClusterCommand";
import {
  GetClusterSnapshotCommandInput,
  GetClusterSnapshotCommandOutput,
} from "../commands/GetClusterSnapshotCommand";
import {
  GetPendingMaintenanceActionCommandInput,
  GetPendingMaintenanceActionCommandOutput,
} from "../commands/GetPendingMaintenanceActionCommand";
import {
  ListClustersCommandInput,
  ListClustersCommandOutput,
} from "../commands/ListClustersCommand";
import {
  ListClusterSnapshotsCommandInput,
  ListClusterSnapshotsCommandOutput,
} from "../commands/ListClusterSnapshotsCommand";
import {
  ListPendingMaintenanceActionsCommandInput,
  ListPendingMaintenanceActionsCommandOutput,
} from "../commands/ListPendingMaintenanceActionsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  RestoreClusterFromSnapshotCommandInput,
  RestoreClusterFromSnapshotCommandOutput,
} from "../commands/RestoreClusterFromSnapshotCommand";
import {
  StartClusterCommandInput,
  StartClusterCommandOutput,
} from "../commands/StartClusterCommand";
import {
  StopClusterCommandInput,
  StopClusterCommandOutput,
} from "../commands/StopClusterCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateClusterCommandInput,
  UpdateClusterCommandOutput,
} from "../commands/UpdateClusterCommand";
export declare const se_ApplyPendingMaintenanceActionCommand: (
  input: ApplyPendingMaintenanceActionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CopyClusterSnapshotCommand: (
  input: CopyClusterSnapshotCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateClusterCommand: (
  input: CreateClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateClusterSnapshotCommand: (
  input: CreateClusterSnapshotCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteClusterCommand: (
  input: DeleteClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteClusterSnapshotCommand: (
  input: DeleteClusterSnapshotCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetClusterCommand: (
  input: GetClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetClusterSnapshotCommand: (
  input: GetClusterSnapshotCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetPendingMaintenanceActionCommand: (
  input: GetPendingMaintenanceActionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListClustersCommand: (
  input: ListClustersCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListClusterSnapshotsCommand: (
  input: ListClusterSnapshotsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListPendingMaintenanceActionsCommand: (
  input: ListPendingMaintenanceActionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_RestoreClusterFromSnapshotCommand: (
  input: RestoreClusterFromSnapshotCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StartClusterCommand: (
  input: StartClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StopClusterCommand: (
  input: StopClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateClusterCommand: (
  input: UpdateClusterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_ApplyPendingMaintenanceActionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ApplyPendingMaintenanceActionCommandOutput>;
export declare const de_CopyClusterSnapshotCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CopyClusterSnapshotCommandOutput>;
export declare const de_CreateClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateClusterCommandOutput>;
export declare const de_CreateClusterSnapshotCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateClusterSnapshotCommandOutput>;
export declare const de_DeleteClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteClusterCommandOutput>;
export declare const de_DeleteClusterSnapshotCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteClusterSnapshotCommandOutput>;
export declare const de_GetClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetClusterCommandOutput>;
export declare const de_GetClusterSnapshotCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetClusterSnapshotCommandOutput>;
export declare const de_GetPendingMaintenanceActionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetPendingMaintenanceActionCommandOutput>;
export declare const de_ListClustersCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListClustersCommandOutput>;
export declare const de_ListClusterSnapshotsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListClusterSnapshotsCommandOutput>;
export declare const de_ListPendingMaintenanceActionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListPendingMaintenanceActionsCommandOutput>;
export declare const de_ListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const de_RestoreClusterFromSnapshotCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RestoreClusterFromSnapshotCommandOutput>;
export declare const de_StartClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartClusterCommandOutput>;
export declare const de_StopClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StopClusterCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateClusterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateClusterCommandOutput>;
